#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int N, M;
vector<int> typy;
vector< vector<int> > teleporty;

int main() {
    cin >> N >> M;
    typy.resize(N+1);
    for (int n=1; n<=N; ++n) cin >> typy[n];
    teleporty.resize(M,vector<int>(2));
    for (int m=0; m<M; ++m) cin >> teleporty[m][0] >> teleporty[m][1];

    // prve prehladavanie: najdeme vsetky nebezpecne
    vector<bool> nebezpecne(N+1,false);    
    for (int n=1; n<=N; ++n) if (typy[n]<2) nebezpecne[n]=true;
    while (true) {
        bool zmena=false;
        for (int m=0; m<M; ++m) 
            if (!nebezpecne[teleporty[m][0]] && nebezpecne[teleporty[m][1]])
                nebezpecne[teleporty[m][0]] = zmena = true;
        if (!zmena) break;
    }

    // druhe prehladavanie: najdeme vsetky znesitelne
    vector<bool> znesitelne(N+1,false);    
    for (int n=1; n<=N; ++n) if (!nebezpecne[n]) znesitelne[n]=true;
    while (true) {
        bool zmena=false;
        for (int m=0; m<M; ++m) 
            if (!znesitelne[teleporty[m][0]] && znesitelne[teleporty[m][1]] && typy[teleporty[m][0]]>0)
                znesitelne[teleporty[m][0]] = zmena = true;
        if (!zmena) break;
    }

    // vypis vysledku
    cout << "bezpecne:";
    for (int n=1; n<=N; ++n) if (!nebezpecne[n]) cout << " " << n;
    cout << endl << "snesitelne:";
    for (int n=1; n<=N; ++n) if (nebezpecne[n] && znesitelne[n]) cout << " " << n;
    cout << endl;
}
